#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "fft.h"
#include "sound.h"
#include "wave.h"
#include "xml.h"

//==================================================
// K֐EJIP֐
//==================================================
int Normalize(const char* pcFilePath, bool bKaraokize, int nMaxLevel) {
	//----------------------------------------
	// WAVEt@CJ
	//----------------------------------------
	WAVE* poWave;

	poWave = new WAVE();
	if(!poWave->OpenWave(pcFilePath)) {
		delete poWave;
		return 0;
	};
	if(bKaraokize && (poWave->wfcWavFmt.usChannels == 1)) {
		delete poWave;
		return 0;
	};
	poWave->ConvertFormat(2, 44100, 16);

	if(bKaraokize) {
		poWave->Karaokize();
	};
//	poWave->Monauralize();

	//----------------------------------------
	// FFTÉEʕ␳
	//----------------------------------------
	FFT* poFft;
	SOUND *poSound;
	int nLen = 4096;
	COMPLEX_NUMBER* pcnFftData;
	COMPLEX_NUMBER* pcnTmp;
	unsigned long ulNumOfBlock;
	unsigned long i;
	int j;
	int k;
	double dPressure = 0;
//	short sSampleValue;
//	long lSampleMaxValue = 0;

	// FFTE
	pcnFftData = (COMPLEX_NUMBER*)malloc(sizeof(COMPLEX_NUMBER) * nLen);
	pcnTmp = (COMPLEX_NUMBER*)malloc(nLen * sizeof(COMPLEX_NUMBER));
	poFft = new FFT(nLen);
	poSound = new SOUND(poWave->wfcWavFmt.ulSamplesPerSec, nLen);
	ulNumOfBlock = poWave->ulSoundDataLen / poWave->wfcWavFmt.usBlockAlign / nLen;
	for(i = 0; i < ulNumOfBlock; i++) {
		for(k = 0; k < poWave->wfcWavFmt.usChannels; k++) {
			for(j = 0; j < nLen; j++) {
				pcnFftData[j].i = 0;
				pcnFftData[j].r = (double)poWave->GetSampleValue(i * nLen + j, k);
/*				sSampleValue = poWave->GetSampleValue(i * nLen + j, k);
				pcnFftData[j].r = (double)sSampleValue;
				if(abs(sSampleValue) > lSampleMaxValue) {
					lSampleMaxValue = abs(sSampleValue);
				};*/
			};
//			poFft->WndFunc(pcnFftData, FALSE);
			poFft->CalcFFT(pcnFftData, pcnTmp, nLen, FALSE);
			dPressure += poSound->GetPressure(pcnFftData);
		};
		if(i % 100 == 0) {
			printf("͊: %d/%d\n", i, ulNumOfBlock);
		};
	};
	dPressure /= ulNumOfBlock;
	printf("ω: %f\n", dPressure);
	Sleep(1000);

	// ʕ␳
	unsigned long ulNumOfSamples = poWave->ulSoundDataLen / poWave->wfcWavFmt.usBlockAlign;

//	lSampleMaxValue = (double)lSampleMaxValue * 7000 / dPressure;
//	poSound->SetStrainedCurve(lSampleMaxValue);
	for(i = 0; i < ulNumOfSamples; i++) {
		if(i % 100000 == 0) {
			printf("␳: %d/%d\n", i, ulNumOfSamples);
		};
		poWave->SetSampleValue(poSound->GetStrainedValue((double)poWave->GetSampleValue(i, 0) * (double)nMaxLevel / dPressure), i, 0);
		poWave->SetSampleValue(poSound->GetStrainedValue((double)poWave->GetSampleValue(i, 1) * (double)nMaxLevel / dPressure), i, 1);
	};
	printf("\n\n");

	delete poFft;
	delete poSound;
	free(pcnFftData);

	//----------------------------------------
	// WAVEt@C̕ۑ
	//----------------------------------------
	char* pcSavePath;

	pcSavePath = (char*)malloc(lstrlen(pcFilePath) + 4);
	lstrcpy(pcSavePath, pcFilePath);
	if(bKaraokize) {
		lstrcpy(pcSavePath + lstrlen(pcSavePath) - 4, "_kr.wav");
	} else {
		lstrcpy(pcSavePath + lstrlen(pcSavePath) - 4, "_cr.wav");
	};

	poWave->CutSilence();
	poWave->SaveWave(pcSavePath);
	free(pcSavePath);

	delete poWave;

	return 0;
};

//==================================================
// C֐
//==================================================
int main(int nArgc, const char** ppcArgv) {

	// ϐ錾
	int i;
	int nPathLen;
	char* pcCmdParam;
	char* pcWavPath = NULL;
	bool bTmpWav = FALSE;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	// ő僌x̎擾
	XML *pXml;
	int nElmId;
	int nMaxLevel;
	char* pcSelfPath;
	bool bKaraokize = FALSE;
	bool bNormalize = FALSE;
	char acLamePath[MAX_PATH + 1];

	pcSelfPath = (char*)malloc(MAX_PATH + 1);
	GetModuleFileName(NULL, pcSelfPath, MAX_PATH);
	for(i = MAX_PATH - 1; i >= 0; i--) {
		if(pcSelfPath[i] == 0x5C) {
			pcSelfPath[i + 1] = NULL;
			break;
		};
	};
	lstrcat(pcSelfPath, "config.xml");
	pXml = new XML();
	pXml->Load(pcSelfPath);
	nElmId = pXml->poRoot->GetElmID("maxLevel", 0);
	if(nElmId != -1) {
		nMaxLevel = atoi(pXml->poRoot->ppoElms[nElmId]->pcContent);
	} else {
		nMaxLevel = 7000;
	};
	nElmId = pXml->poRoot->GetElmID("karaokize", 0);
	if((nElmId != -1) && (lstrcmp(pXml->poRoot->ppoElms[nElmId]->pcContent, "yes") == 0)) {
		bKaraokize = TRUE;
	};
	nElmId = pXml->poRoot->GetElmID("normalize", 0);
	if((nElmId != -1) && (lstrcmp(pXml->poRoot->ppoElms[nElmId]->pcContent, "yes") == 0)) {
		bNormalize = TRUE;
	};
	nElmId = pXml->poRoot->GetElmID("lamePath", 0);
	if(nElmId != -1) {
		lstrcpy((LPSTR)&acLamePath, pXml->poRoot->ppoElms[nElmId]->pcContent);
	};
	delete pXml;
	free(pcSelfPath);

	// KEJIP
	for(i = 1; i < nArgc; i++) {

		// MP3̃fR[h
		bTmpWav = FALSE;
		nPathLen = lstrlen(ppcArgv[i]);
		if(
			(ppcArgv[i][nPathLen - 4] == 0x2E) &&
			((ppcArgv[i][nPathLen - 3] == 0x6D) || (ppcArgv[i][nPathLen - 3] == 0x4D)) &&
			((ppcArgv[i][nPathLen - 2] == 0x70) || (ppcArgv[i][nPathLen - 2] == 0x50)) &&
			((ppcArgv[i][nPathLen - 1] == 0x33) || (ppcArgv[i][nPathLen - 1] == 0x32))
		) {
			pcWavPath = (char*)malloc(nPathLen + 1);
			lstrcpy(pcWavPath, ppcArgv[i]);
			lstrcpy(&pcWavPath[nPathLen - 3], "wav");

			pcCmdParam = (char*)malloc(2 * nPathLen + 16);
			lstrcpy(pcCmdParam, " --decode \"");
			lstrcat(pcCmdParam, ppcArgv[i]);
			lstrcat(pcCmdParam, "\" \"");
			lstrcat(pcCmdParam, pcWavPath);
			lstrcat(pcCmdParam, "\"");
			FillMemory(&si, sizeof(STARTUPINFO), 0);
			FillMemory(&pi, sizeof(PROCESS_INFORMATION), 0);
			si.cb = sizeof(STARTUPINFO);
			CreateProcess((LPSTR)&acLamePath, pcCmdParam, NULL, NULL, FALSE, NULL, NULL, NULL, &si, &pi);
			WaitForSingleObject(pi.hProcess, INFINITE);
			bTmpWav = TRUE;
			free(pcCmdParam);
			printf("\n");
		};

		// WAVt@C̃pX擾
		if(pcWavPath == NULL) {
			pcWavPath = (char*)malloc(nPathLen + 1);
			lstrcpy(pcWavPath, ppcArgv[i]);
		};
		printf("%s\n", pcWavPath);

		// K
		if(bNormalize) {
			Normalize(pcWavPath, FALSE, nMaxLevel);
		};

		// JIP
		if(bKaraokize) {
			Normalize(pcWavPath, TRUE, nMaxLevel);
		};

		// WAVEt@C̍폜(MP3ϊꍇ̂)
		if(bTmpWav) {
			DeleteFile(pcWavPath);
		};
		free(pcWavPath);
		pcWavPath = NULL;
	};

	return 0;
};
