#include <math.h>
#include <windows.h>
#include <stdio.h>

#include "fft.h"

//----------------------------------------
// RXgN^
//----------------------------------------
FFT::FFT(int nLen) {

	// ϐ̐錾
	int i;

	// ݒ
	nLEN = nLen;
	pcnW = (COMPLEX_NUMBER*)malloc(nLEN * sizeof(COMPLEX_NUMBER));
	for(i = 0; i < nLEN; i++) {
		pcnW[i].r = cos(2 * MATH_PI * i / nLEN);
		pcnW[i].i = -sin(2 * MATH_PI * i / nLEN);
	};

	pdWndFunc = (double*)malloc(nLEN * sizeof(double));
	for(i = 0; i < nLEN; i++) {
		pdWndFunc[i] = 0.5 - 0.5 * cos(2 * MATH_PI * i / (nLEN - 1));
	};
};

//----------------------------------------
// fXgN^
//----------------------------------------
FFT::~FFT() {
	free(pcnW);
	free(pdWndFunc);
};

//----------------------------------------
// ֐
//----------------------------------------
void FFT::WndFunc(COMPLEX_NUMBER* pcnA, bool bImaginary) {
	int i;

	for(i = 0; i < nLEN; i++) {
		pcnA[i].r *= pdWndFunc[i];
		if(bImaginary) {
			pcnA[i].i *= pdWndFunc[i];
		};
	};
};

//----------------------------------------
// FFTZ֐
//----------------------------------------
void FFT::CalcFFT(COMPLEX_NUMBER* pcnA, COMPLEX_NUMBER* pcnTmp, int nLen, bool bInv) {
	
	// ϐ̐錾
	int k;
	int l;
	int nHalfLen = nLen / 2;

	// 1̂Ƃ̃^[
	if(nLen <= 1) {
		return;
	};

	// Eŕ
	for(k = 0; k < nHalfLen; k++) {
		pcnTmp[k].r = pcnA[k].r + pcnA[nHalfLen + k].r;
		pcnTmp[k].i = pcnA[k].i + pcnA[nHalfLen + k].i;
		if(k == 0) {
			pcnTmp[nHalfLen + k].r = pcnA[k].r - pcnA[nHalfLen + k].r;
			pcnTmp[nHalfLen + k].i = pcnA[k].i - pcnA[nHalfLen + k].i;
		} else if(k == nLen / 4) {
			if(bInv) {
				pcnTmp[nHalfLen + k].r = - (pcnA[k].i - pcnA[nHalfLen + k].i);
				pcnTmp[nHalfLen + k].i = pcnA[k].r - pcnA[nHalfLen + k].r;
			} else {
				pcnTmp[nHalfLen + k].r = pcnA[k].i - pcnA[nHalfLen + k].i;
				pcnTmp[nHalfLen + k].i = - (pcnA[k].r - pcnA[nHalfLen + k].r);
			};
		} else {
			l = k * nLEN / nLen;
			if(bInv) {
				l = (nLEN - l) % nLEN;
			};
			pcnTmp[nHalfLen + k].r = (pcnA[k].r - pcnA[nHalfLen + k].r) * pcnW[l].r - (pcnA[k].i - pcnA[nHalfLen + k].i) * pcnW[l].i;
			pcnTmp[nHalfLen + k].i = (pcnA[k].i - pcnA[nHalfLen + k].i) * pcnW[l].r + (pcnA[k].r - pcnA[nHalfLen + k].r) * pcnW[l].i;
		};
	};

	// AVFFTf[^Ƃ݂ȂčČvZ
	CalcFFT(pcnTmp, pcnA, nHalfLen, bInv);
	CalcFFT(&pcnTmp[nHalfLen], pcnA, nHalfLen, bInv);

	// ]
	for(k = 0; k < (nLen / 2); k++) {
		pcnA[2 * k].r = pcnTmp[k].r;
		pcnA[2 * k + 1].r = pcnTmp[nHalfLen + k].r;
		pcnA[2 * k].i = pcnTmp[k].i;
		pcnA[2 * k + 1].i = pcnTmp[nHalfLen + k].i;
	};

	// tZ̏
	if(bInv && (nLen == nLEN)) {
		for(k = 0; k < nLen; k++) {
			pcnA[k].r /= nLEN;
			pcnA[k].i /= nLEN;
		};
	};
};
