#ifndef __WAVE_CLASS__
#define __WAVE_CLASS__

typedef struct {
	char acChunkId[4];
	unsigned long ulChunkSize;
	short sFormatTag;
	unsigned short usChannels;
	unsigned long  ulSamplesPerSec;
	unsigned long  ulAvgBytesPerSec;
	unsigned short usBlockAlign;
	unsigned short usBitsPerSample;
} WAVE_FORMAT_CHUNK;

class WAVE {
private:
	unsigned char* pucWavData;
	unsigned char* pucSoundData;
	DWORD dwWavDataSize;

	bool CmpStr(const unsigned char* pucStr1, const unsigned char* pucStr2, int nSize);

public:
	unsigned long ulSoundDataLen;
	WAVE_FORMAT_CHUNK wfcWavFmt;

	WAVE();
	~WAVE();

	bool OpenWave(const char* pcFilePath);
	bool SaveWave(const char* pcFilePath);
	short GetSampleValue(unsigned long ulSampleNum, int nChannel);
	void SetSampleValue(short sValue, unsigned long ulSampleNum, int nChannel);
	void CutSilence();
	void Karaokize();
	void ConvertFormat(unsigned short _usChannels, unsigned long _ulSamplesPerSec, unsigned short _usBitsPerSample);
};

#endif