#ifndef XML_HEADER
#define XML_HEADER

#include <windows.h>
#include "CharSet.h"

//==================================================
// \̂̐錾
//==================================================
struct XML_ATTR {
	char* pcAttrName;
	char* pcAttrValue;
};

struct XML_ENTITY {
	char* pcEntityName;
	char* pcEntityValue;
};

//==================================================
// XMLElmNX
//==================================================
class XMLElm {
public:
	int nLevel;
	char* pcElmName;
	int nNumOfAttr;
	XML_ATTR* psAttr;
	XMLElm** ppoElms;
	int nNumOfElms;
	char* pcContent;
	int nContentLen;
	bool bEmpty;
	bool bDeleted;

	XMLElm(int _nLevel);
	~XMLElm();

	void ReadElms(unsigned char* pucXMLData, DWORD& dwCurPos, bool bOnlyContent, bool bCDATA);
	void WriteElms(HANDLE hFile);
	void SetElmName(char* pcNewElmName);
	int AddElm(char* pcNewElmData, bool bCDATA);
	int AddElm(char* pcNewElmName, char* pcNewElmContent, bool bCDATA);
	int AddAttr(char* pcNewAttrName, char* pcNewAttrValue);
	void ChangeContent(char* pcNewContent, bool bCDATA);
	int GetElmID(const char* pcElmName, int nStartID);
	int GetAttrID(const char* pcAttrName);
	void DeleteElm();
	void ChangeAttrValue(int nAttrID, char* pcNewAttrValue);
};

//==================================================
// XMLNX
//==================================================
class XML {

private:

	bool ReadXML(const char* pcFilePath);
	void ReadProlog();
	void ReadDTD(char* pcDTDData, DWORD& dwDTDCurPos, int nEndPos);
	
	void WriteXML(const char* pcFilePath);

public:

	unsigned char* pucXMLData;
	DWORD dwCurPos;
	XMLElm* poRoot;
	static XML_ENTITY* psEntities;
	static int nNumOfEntities;
	static int nNumOfObjects;

	XML();
	~XML();
	static void SkipS(unsigned char* pucXMLData, DWORD& dwCurPos);
	static bool CheckStr(char* pcStr, unsigned char* pucXMLData, DWORD& dwCurPos);
	static int GetEntityID(const char* pcEntityName);
	void Load(const char* pcFilePath);
	void Save(const char* pcFilePath, bool bOverWrite);

};

#endif
